//------------------------------------------
// Includes
//------------------------------------------
#include "main.h"


//------------------------------------------
// 2do-Liste
//------------------------------------------
//
//	X Wenn falscher Frame auf seriell, geht der Empfang danach gar nicht mehr


//------------------------------------------
// Haupteinstiegsroutine
//------------------------------------------
int main()
{
/*TestPWM	*/
	uint8_t gas 	= MORE_GAS;
	uint8_t pwm 	= 0;
	uint32_t temp 	= 0;
	uc_init();	// C initialisieren

	PORTC |= (1<<PC1);	// Motoren enable
/*	PORTD |= (1<<PD7);	// Richtung Motor 0 festlegen
	PORTD |= (1<<PD4);	// Richtung Motor 1 festlegen
	PORTD |= (1<<PB0);	// Richtung Motor 0 festlegen
	PORTD |= (1<<PD2);	// Richtung Motor 1 festlegen
*/	
	PORTD &= ~(1<<PD7);	// Richtung Motor 0 festlegen
	PORTD &= ~(1<<PD4);	// Richtung Motor 1 festlegen
	PORTD &= ~(1<<PB0);	// Richtung Motor 0 festlegen
	PORTD &= ~(1<<PD2);	// Richtung Motor 1 festlegen

//	PORTD &= ~(1<<PD7);
	for(;;)		// Endlos-Schleife
	{
		switch (gas) 
    	{
        case MORE_GAS:
            if (++pwm == 255)
			{
                gas = LESS_GAS;
//				uart_puts("langsamer\n\r");
			}
            break;

        case LESS_GAS:
            if (--pwm == 0)
			{
                gas = MORE_GAS;
//				uart_puts("schneller\n\r");
			}
            break;
   		}

    OCR0A = pwm;
	OCR0B = pwm;
	OCR1A = pwm;
	OCR1B = pwm;

	UDR0 = pwm;
	for (temp=0;temp<1000;temp++);
	UDR0 = ReadChannel(4);
	for (temp=0;temp<1000;temp++);
	UDR0 = 0xff;
	/*UDR0 = ReadChannel(5);
	for (temp=0;temp<1000;temp++);
	UDR0 = ReadChannel(6);
	for (temp=0;temp<1000;temp++);
	UDR0 = ReadChannel(7);
	for (temp=0;temp<1000;temp++);
	UDR0 = 0xff;
//	OCR2A = pwm;
//	OCR2B = pwm;*/
	for (temp=0;temp<10000;temp++);
	}

/*TestSPI-input-sr
	uc_init();
	unsigned long delay =0 ;
	for(;;)
	{
/*		if (uart0.send != true)
		{	unsigned int temp = sr_get();
			uart0.out_buffer[1] = (uint8_t)(temp); 			// Low-Byte
			uart0.out_buffer[0] = (uint8_t)(temp >> 8); 	// High-Byte
		
			uart0.out_payload = 2;
			uart0.send = true;
		}
		if (uart0.send == true)
			UCSR0B |= (1<<UDRIE0);
*/
		
/*
		if (uart0.rec_complete == true)
		{
			uart0.out_payload = uart0.in_payload ;
			strcpy (uart0.out_buffer, uart0.in_buffer);
			uart0.send = true;
			uart0.rec_complete = false;
		}*/
/*		sr_set(0xff);
		UDR0 = '1';
		for (delay = 0; delay < 100000; delay++);
		sr_set(0x00);
		UDR0 = '0';
		for (delay = 0; delay < 100000; delay++);
	}*/


	return 0;
}


//------------------------------------------
// Initialiserungsroutine
//------------------------------------------
void uc_init()
{
	// IO Initialisieren
	DDRB	= (1<<PB0) | (1<<PB1) | (1<<PB2);						// Pin 0-2 als  Output, Rest Input
	PORTB	= (1<<PB3) | (1<<PB4) | (1<<PB5) | (1<<PB6) | (1<<PB7);	// Pin 0-2 auf LOW, Rest interner Pullup

	DDRC	= (1<<PC0) | (1<<PC1);									// Pin 0-1 als  Output, Rest Input
	PORTC	= (1<<PC2) | (1<<PC3) | (1<<PC6);						// Pin 0-1 auf LOW, Rest interner Pullup

	DDRD 	= 254;	// Alle Pins Output
	PORTD 	= 0;	// Alle Pins auf LOW

	// Timer/PWM initialisieren
	
	// Timer 0
    TCCR0A 	= (1<<COM0A1) | (1<<COM0B1) | (1<<WGM01) | (1<<WGM00);	// Fast PWM, Clear OC0A on compare match
	TCCR0B 	= (1<<CS00);											// Prescaler 1	
	OCR0A 	= 0;													// OCR der Timer auf 0
	OCR0B 	= 0;													// 
	
	// Timer 1
    TCCR1A 	= (1<<COM1A1) | (1<<COM1B1) | (1<<WGM10);				// Fast PWM, Clear OC0A on compare match
	TCCR1B 	= (1<<WGM12) | (1<<CS00);								// Prescaler 1, 8Bit Mode	
	OCR1A 	= 0;													// OCR der Timer auf 0
	OCR1B 	= 0;													// 

	// Timer 2
//	TCCR2A 	= (1<<COM2A1) | (1<<COM2B1) | (1<<WGM21) | (1<<WGM20);	// Fast PWM, Clear OC0A on compare match
//	TCCR2B 	= (1<<CS20);											// Prescaler 1	
//	OCR2A 	= 0;													// OCR der Timer auf 0
//	OCR2B 	= 0;													//

	// Timer-Interrupts
//	TIMSK0 = (1<<TOIE0) | (1<<OCF0A);

	uart_init();// UART0 initialisieren
	spi_init();	// SPI initialisieren

    sei ();		// global interrupt enable
}

